package com.tree.binary

import com.tree.binary.CuttingBinaryTreeApp.IndexWithWeight
import com.tree.binary._

/**
  * Created by nk91 on 20.04.17.
  */
object BinaryTreesExample {

  // format: off
  val tree: Tree[IndexWithWeight] =
    (
                (
                  N(1, -3)
                         -->
                            N(2, 10)
                         <--
                  N(3, 0)
                )
                                    -->
                                       N(4, 0)
                                    <--
      (
                  N(5, -3)
                         -->
                            N(6, 1)
                         <--
      (
        N(7, 0)
               -->
                  N(8, -1)
      )

      )
  )

  //              0
  //      _______/  \_______
  //      10              1
  //  ___/  \___      ___/  \___
  //  -3      0       -3      -1
  //                        _/
  //                        0
  // Expected results:
  // cuts nodes
  //   0    0
  //   1    1
  //   2    2
  //   3    3
  //   4    3
  // SubTrees weight: 1

  val tree2: Tree[IndexWithWeight] =
    (
      (
        (
          N(1, -8)
                  -->
                     N(2, 0)
        )
                            -->
                               N(3, 3)
                            <--
        (
          N(4, -3)
                  -->
                     N(5, -2)
                  <--
          N(6, 1)
        )
      )
                                      -->
                                         N(7, 12)
                                      <--
      (
        (
          N(8, -7)
                  -->
                     N(9, 0)
                  <--
          N(10, 7)
        )
                            -->
                               N(11, 4)
                            <--
        (
          N(12, -6)
                   -->
                      N(13, -5)
                   <--
          N(14, 1)
        )
      )
  )

  //               12
  //       _______/  \_______
  //       3               4
  //   ___/  \___      ___/  \___
  //   0       -2      0       -5
  // _/      _/  \_  _/  \_  _/  \_
  // -8      -3  1   -7  7   -6  1

  val expectedResultForTree2 = List(
    (1, -10),
    (2, -19),
    (3, -26),
    (4, -29),
    (5, -29)
  )

  val tree3: Tree[IndexWithWeight] =
    (
                    ((
                      N(1,-6)
                               -->
                                  N(2, 3)
                               <--
                      N(3, -7)
                    )
                                            -->
                                               N(4, -2)
                                            <--
                    (
                      N(5,-15)
                               -->
                                  N(6, 13)
                    ))
                                                         -->
                                                            N(7, 22)
                                                         <--
    (((
        N(8, 8)
                  -->
                      N(9, -7)
                  <--
        N(10, -2)
    )
                               -->
                                  N(11, -6)
                               <--
                      N(12, 2)
      )
                                           -->
                                              N(13, 20)
                                           <--
                                 N(14, -16)
     )
     )
  //                                             22
  //                     _______________________/   \_______________________
  //                     -2                                              20
  //         ___________/   \___________                     ___________/   \___________
  //         3                       13                      -6                      -16
  //   _____/   \_____         _____/                  _____/   \_____
  //   -6          -7          -15                     -7          2
  //                                                __/   \__
  //                                                8     -2
  // format: on

  val testCasesForTree3 = List(
    (1, -16),
    (2, -31),
    (3, -41),
    (4, -46),
    (5, -46),
    (6, -46)
  )

}
